(* ROMAI.PAS *)

Program Romai_Szamok;
uses crt;

{ Arab szmot (1-3999), rmai szmm alakt fggvnny }
  function Arab_Romai(arab : word) : string;
    type
       tszam = array[0..9] of string[4];
    const
       egyes  : tszam = ('', 'I', 'II', 'III', 'IV',
                         'V', 'VI', 'VII', 'VIII', 'IX');
       tizes  : tszam = ('', 'X', 'XX', 'XXX', 'XL',
                         'L', 'LX', 'LXX', 'LXXX', 'XC');
       szazas : tszam = ('', 'C', 'CC', 'CCC', 'CD',
                         'D', 'DC', 'DCC', 'DCCC', 'CM');
       ezres  : tszam = ('', 'M', 'MM', 'MMM','','','','','','');
    begin
       Arab_Romai := ezres [(arab div 1000)] +
                     szazas[((arab mod 1000) div 100)] +
                     tizes [(((arab mod 1000) mod 100) div 10)] +
                     egyes [(((arab mod 1000) mod 100) mod 10)]
    end;  { Arab_Romai}

{ Rmai szmot, arab szmm alakt fggvnny }
{ -1 rtket ad vissza, ha valami hibs       }
  function Romai_Arab(romai : string) : integer;

    function szamjegy(ch : char) : Integer;
      begin
        Case ch of
          'I' : szamjegy:=1;
          'V' : szamjegy:=5;
          'X' : szamjegy:=10;
          'L' : szamjegy:=50;
          'C' : szamjegy:=100;
          'D' : szamjegy:=500;
          'M' : szamjegy:=1000;
          else  szamjegy:=-1;
        end;
      end;  { szamjegy }

    { true rtket ad, ha a ch  5, 50 vagy 500 }
    function otose(ch : char) : boolean;
      begin
        otose:=ch in ['V','L','D'];
      end;  { otose }

  var
    pozicio         : byte;
    ertek, aktertek : integer;
    lnelozoertek    : integer;
  begin
    pozicio:=length(romai);
    ertek:=0;
    lnelozoertek:=szamjegy(romai[pozicio]);
    while pozicio > 0 do
     begin
        aktertek:=szamjegy(romai [pozicio]);
        if aktertek<0 then
           begin
             Romai_Arab:=-1;
             Exit;
           end;
        if aktertek >= lnelozoertek then
           begin
             ertek:=ertek+aktertek;
             lnelozoertek:=aktertek;
           end
         else
           begin
             if otose(romai [pozicio]) then
                begin
                  Romai_Arab:=-1; { ts nem llhat ms eltt! }
                  Exit;
                end;
             if lnelozoertek div aktertek > 10 then
                begin
                  Romai_Arab:=-1; { pl. 'XM', 'IC', 'XD'... }
                  Exit;
                end;
             ertek:=ertek-aktertek;
           end;
        Dec(pozicio);
     end;
    Romai_Arab:=ertek;
  end;   { Romai_Arab }



var
  aszam : integer;
  rsz   : string;
begin
  clrscr;
  writeln('A rmai szmok 1990 s 2010 kztt:');
  writeln;
  for aszam:=1990 to 2010 do
   begin
    rsz:= Arab_Romai(aszam);
    writeln(aszam:4, ' = ', rsz : 10, ' = ':4, Romai_Arab(rsz):6)
   end;
    aszam:=0;
    rsz:= 'LLIIXMXX';
    writeln(aszam:4, ' = ', rsz : 10, ' = ':4, Romai_Arab(rsz):6)
end.

