(* naptar.pas *)

{  NAPTAR.PAS
   Naptrprogram : 1900-tl
   jelenti meg az naptrat }

program naptar_program;
uses crt, dos;
const
     kicsi =    3;
     nagy  =	4;

type

  Unnepnap = record
	      honap : byte;
	      nap   : byte;
	      end;

const
   Ugras   : array[1..12] of byte = ( 1, 4, 4, 0, 2, 5, 0, 3, 6, 1, 4, 6 );
   HonapNap:array[1..12 ] of byte = ( 31, 28, 31, 30, 31, 30, 31,
                                      31, 30, 31, 30, 31 );
   HonapNev:array[1..12] of string[15] =
                                ( 'janur',   'februr',   'mrcius',
				  'prilis',  'mjus',     'jnius',
				  'jlius',   'augusztus', 'szeptember',
				  'oktber',  'november',  'december' );

  Unnep : array[0..10] of UnnepNap =
                                ((honap: 0;nap: 0),   { Hsvt }
				 (honap: 0;nap: 0),
				 (honap: 0;nap: 0),   { Pnksd }
				 (honap: 0;nap: 0),
				 (honap: 1;nap: 1),
				 (honap: 3;nap:15),
				 (honap: 5;nap: 1),
				 (honap: 8;nap:20),
				 (honap:10;nap:23),
				 (honap:12;nap:25),
				 (honap:12;nap:26));

    Nagy_fejlec =  ' H   K   Sz  Cs  P   Sz  V' ;
    Kis_fejlec  =  'H  K  Sz Cs P  Sz  V' ;

procedure Keret( sor, oszlop, szelesseg, magassag : integer);forward;
function  Unnep_e(honap, nap:integer):boolean;forward;
procedure Vonal( sor, oszlop, szelesseg : integer;
	         bal, kozep, jobb : char ); forward;

{ ------------------------------------------------------ }
{ Adott v adott hnapjhoz tartoz naptr megjelentse }
{ ------------------------------------------------------ }
procedure Naptar( honap, ev, sor, oszlop, szelesseg : integer;
                  fejlec : string);
var
    kezdet, napok, keret_szelesseg, i : integer;
    str : string[80];
begin
    textcolor(lightgray);
    keret_szelesseg := 7 * szelesseg - 1;
    Keret( sor, oszlop, keret_szelesseg, 8 );
    str := HonapNev[ honap ];
    gotoxy( oszlop + 1 + ( keret_szelesseg - length( str ) - 5 ) div 2 ,
            sor - 1 );

    write(ev+1900:4,'. ', str );
    gotoxy( oszlop + 1,  sor + 1 );
    write( fejlec );

    kezdet := ev + ev div 4 + Ugras[ honap ] + 6;
    if  ( ev mod 4 = 0 ) and ( honap <= 2 ) then dec(kezdet);
    kezdet := kezdet mod 7 + 1;

    if  ( ev mod 4 = 0 ) and ( honap = 2 ) then
	napok := 29
     else
	napok := HonapNap[ honap ];

    sor := sor + 3;
    for i := 1 to napok do
     begin
	gotoxy( oszlop + szelesseg * kezdet - 2,  sor);
	if kezdet=7 then textcolor(YELLOW)
                    else textcolor(WHITE);
	if Unnep_e(honap,i) then textcolor(LIGHTRED);

	write( i:2 );
	if( kezdet = 7 ) then
          begin
	    writeln;
	    inc(sor);
	    kezdet := 1;
	  end
        else
	    inc(kezdet);
    end;
end;

{ --------------- }
{ Keret rajzolsa }
{ --------------- }
procedure Keret( sor, oszlop, szelesseg, magassag : integer);
var
  i : integer;
begin

    Vonal( sor    , oszlop, szelesseg, '', '', '' );
    Vonal( sor + 1, oszlop, szelesseg, '', ' ', '' );
    Vonal( sor + 2, oszlop, szelesseg, '', '', '' );
    for i := 3 to magassag do
	Vonal( sor + i, oszlop, szelesseg, '', ' ', '' );
    Vonal( sor + magassag + 1, oszlop, szelesseg, '', '', '' );
end;

{ ----------------------------------------------- }
{ A keret sorainak rajzolshoz hasznlt fggvny }
{ ----------------------------------------------- }
procedure Vonal( sor, oszlop, szelesseg : integer;
	         bal, kozep, jobb : char );
var
   puffer  : array [0..80] of char;
begin
    puffer[ 0 ] := bal;
    fillchar( puffer[ 1 ],  szelesseg, kozep );
    puffer[ szelesseg + 1 ] := jobb;
    puffer[ szelesseg + 2 ] := #0;
    gotoxy( oszlop , sor );
    write( puffer );
end;

{ ------------------------- }
{ Az nnepnapok ellenrzse }
{ ------------------------- }
function  Unnep_e(honap, nap:integer):boolean;
var
   maxi, i : integer;
   ok : boolean;
begin
   maxi:=sizeof(Unnep) div sizeof(Unnepnap);
   ok:=false;

   for i:=0 to maxi-1 do
     if (ord(Unnep[i].honap)=honap) and (Unnep[i].nap=nap) then  ok:=true;

  Unnep_e:=ok;
end;

{ -------------------------------------------------- }
{ Az adott vhez a Hsvt s Pnksd idpontjnak    }
{ meghatrozsa                                      }
{ -------------------------------------------------- }
procedure Husvet(ev: integer; var honap, nap : integer); forward;

procedure Husvet_Punkosd(ev : integer);
var
 ho, nap : integer;
begin
 Husvet(1900+ev, ho, nap);

 { Hsvt }
 Unnep[0].honap:=ho;
 Unnep[0].nap  :=nap;
 Unnep[1]:=Unnep[0];
 if (nap+1)>HonapNap[ho] then
  begin
    inc(Unnep[1].honap);
    Unnep[1].nap:=1;
  end
 else
  inc(Unnep[1].nap);

 { Pnksd }
 inc(nap,49);
 if (nap>60) then
   begin
     nap:=nap-HonapNap[ho]+HonapNap[ho+1];
     inc(ho,2);
   end
 else
    begin
      nap:=nap-HonapNap[ho];
      inc(ho);
    end;
 Unnep[2].nap:=nap;
 Unnep[2].honap:=ho;
 Unnep[3]:=Unnep[2];
 if ((nap+1)>HonapNap[ho]) then
  begin
    inc(Unnep[2].honap);
    Unnep[2].nap:=1;
  end
 else
   inc(Unnep[2].nap);
end;

{ -------------------------------------------------- }
{ Az adott vhez a Hsvt idpontjnak meghatrozsa }
{ -------------------------------------------------- }
procedure Husvet(ev: integer; var honap, nap : integer);
var
 g,c,x,z,d,e : integer;
begin

 g := ev mod 19 +1;
 c  := ev div 100 +1;
 x  := 3 * c div 4 -12;
 z  := (8*c+5) div 25 -5;
 d  := 5 * ev div 4 -x -10;
 e  := (11* g + 20 +z -x) mod 30;

 if (e < 0) then inc(e,30);
 if  (e=25) and (g>11) or (e=24) then inc(e);
 nap := 44-e;

 if (nap<21) then inc(nap,30);
 nap := nap+ 7-(d+nap) mod 7;

 if (nap>31) then
   begin
    dec(nap,31);
    honap:=4;
   end
  else
    honap:=3;
end;


{ ----------- }
{ A fprogram }
{ ----------- }

var
   aktev, aktho, sv : word;

begin
    clrscr;
    { az aktulis dtum lekrdezse }
    if (paramcount<>2) then
     begin
       GetDate(aktev, aktho, sv, sv);
       aktev:=aktev-1900;
     end
     else
     begin
       val(paramstr(1),aktev,sv);
       if sv<>0 then halt;
       aktev:=aktev-1900;
       val(paramstr(2),aktho,sv);
       if sv<>0 then halt;
     end;

    Husvet_Punkosd(aktev);

    { az aktulis hnap naptra }
    Naptar( aktho, aktev, 5, 26, nagy, Nagy_fejlec );

    { az elz hnap naptra }
    dec(aktho);
    if( aktho < 1 ) then
    begin
	aktho := 12;
	dec(aktev);
    end;
    Naptar( aktho, aktev, 10, 3, kicsi, Kis_fejlec );

    { a kvetkez hnap naptra }
    inc(aktho,2);
    if( aktho > 12 ) then
      begin
	aktho:= aktho-12;
	inc(aktev);
    end;
    Naptar( aktho, aktev, 10, 56, kicsi, Kis_fejlec );
    gotoxy( 1, 22);
end.
