{ Egyszerre egy DBase llomny rsa, olvassa }

unit dbaseu;

interface

type
   db_file = record                    { a dBASE III+ fileler rekordja }
              memo         : byte;
              akt_ev       : byte;
              akt_ho       : byte;
              akt_nap      : byte;
              rekordok     : longint;
              fejreszhossz : word;
              rekordhossz  : word;
              fenntartva   : array [0..19] of byte;

            end;

    db_mezo = record                   { a dBASE III+ mezler rekordja }
                mezonev     : array[0..10] of char;
                mezotipus   : char;
                fenntartva1 : array[0..3] of byte;
                mezohossz   : byte;
                mezodecimal : byte;
                fenntartva2 : array[0..13] of byte;
              end;
var
  dbmezok   : byte;                       { a rekordban lv mezk szma    }
  dbmezoptr : array [1..128] of ^db_mezo; { mutatk a mezler rekordokhoz }

function  db_open(var filenev; var dbfej:db_file):boolean;
procedure db_close(dbfej:db_file);
procedure db_rw(var dbfej:db_file; muvelet:byte; rekordszam:longint);
procedure getfield(mezo:byte; var tartalom:string);
procedure setfield(mezo:byte; tartalom:string);
procedure print_memo(rekord:string);


implementation
uses dos;

type
   tpuffer=array [0..4000] of char;       { aktulis rekord trolsra      }
var
  dbfile,                                 { file_vltoz  *.dbf file-hoz    }
  dbmemo    : file;                       { file_vltoz  *.dbt file-hoz    }
  dbfabs    : filerec absolute dbfile;
  dbmabs    : filerec absolute dbmemo;
  pdbpuffer : ^tpuffer;


{ Feladat : a .dbf s a .dbt llomnyok megnyitsa,                       }
{           a fileler s a mezler rekordok beolvassa                }
{ Input   : filenev - a feldolgozand .dbf llomny neve                  }
{ Output  : dbfej   - a fileler rekord                                  }
{           db_open - true, ha sikeres a file(-ok) megnyitsa             }
{           dbmezok     (glob) - a dBASE rekord mezinek szma            }
{           dbmezoptr[] (glob) - a mezler rekordokra mutat pointerek  }
function db_open( var filenev; var dbfej:db_file):boolean;
 var fnev : string[1] absolute filenev;
     i    : word;
 begin
   db_open:=false;
   assign(dbfile,fnev+'.dbf');
   assign(dbmemo,fnev+'.dbt');
   {$I-}
     reset(dbfile,1);
   {$I+}
   if ioresult<>0 then exit;
   blockread(dbfile,dbfej,sizeof(db_file));
   if (dbfej.memo=$83) then
      begin
        {$I-}
          reset(dbmemo,1);
        {$I+}
        if ioresult<>0 then exit;
      end;
   dbmezok:=(dbfej.fejreszhossz-1) div 32 - 1;
   for i:=1 to dbmezok do
    begin
      getmem(dbmezoptr[i],sizeof(db_mezo));
      blockread(dbfile,dbmezoptr[i]^,sizeof(db_mezo));
   end;
   new(pdbpuffer);
   db_open:=true;
 end;


{ Feladat : a .dbf s a .dbt llomnyok lezrsa,                         }
{           a mezler rekordok ltal hasznlt heap felszabadtsa       }
{ Input   : dbfej   - a fileler rekord                                  }
procedure db_close(dbfej:db_file);
 var i : word;
 begin
   if dbfabs.handle<>0 then close(dbfile);
   if dbmabs.handle<>0 then close(dbmemo);
   for i:=1 to dbmezok do
       freemem(dbmezoptr[i],sizeof(db_mezo));
   dispose(pdbpuffer);
 end;


{ Feladat : read/write mvelet a .dbf llomnyon                          }
{ Input   : dbfej   - a fileler rekord                                  }
{           muvelet - 0 : rekord olvassa                                 }
{                     1 : rekord rsa                                    }
{                     2 : rekord hozzfzse az llomnyhoz               }
{           rekordszam - a feldolgozand rekord sorszma                  }
{           dbpuffer (glob) - az aktulis rekord  1, 2-es mveletnl      }
{ Output  : dbpuffer (glob) - az aktulis rekord  0-s mveletnl         }
{           dbfej           - 2-es mvelet esetn                         }
procedure  db_rw(var dbfej:db_file; muvelet:byte; rekordszam:longint);
 begin
   case muvelet of
    0: {get}
     begin
       seek(dbfile,dbfej.fejreszhossz+(rekordszam-1)*dbfej.rekordhossz);
       blockread(dbfile,pdbpuffer^,dbfej.rekordhossz);
     end;
    1: {put}
     begin
       seek(dbfile,dbfej.fejreszhossz+(rekordszam-1)*dbfej.rekordhossz);
       blockwrite(dbfile,pdbpuffer^,dbfej.rekordhossz);
     end;
    2: {append}
      begin
       seek(dbfile,dbfej.fejreszhossz+(dbfej.rekordok)*dbfej.rekordhossz);
       blockwrite(dbfile,pdbpuffer^,dbfej.rekordhossz);
       inc(dbfej.rekordok);
       reset(dbfile,1);
       blockwrite(dbfile,dbfej,sizeof(db_file));
      end;
    end;
 end;


{ Feladat : a pozicionls egy dBASE rekordmezre a dbpuffer-ban          }
{ Input   : mezo - a feldolgozand mez sorszma                          }
{           dbpuffer    (glob) - a feldolgozand rekord                   }
{           dbmezoptr[] (glob) - a feldolgozand mez lerja             }
{ Output  : pufferptr - pozici a dbpuffer-ban                            }
function pufferptr(mezo:byte):pointer;
 var i,sz:word;
 begin
   sz:=1;
   for i:=1 to mezo-1 do sz:=sz+dbmezoptr[i]^.mezohossz;
   pufferptr:=ptr(seg(pdbpuffer^),ofs(pdbpuffer^)+sz);
 end;


{ Feladat : egy mez kiolvassa a dbpuffer-bl                            }
{ Input   : mezo - a feldolgozand mez sorszma                          }
{           dbpuffer    (glob) - a feldolgozand rekord                   }
{           dbmezoptr[] (glob) - a feldolgozand mez lerja             }
{ Output  : tartalom - a mez tartalma                                    }
procedure getfield(mezo:byte; var tartalom:string);
 begin
   tartalom[0]:=char(dbmezoptr[mezo]^.mezohossz);
   move(pufferptr(mezo)^,tartalom[1],dbmezoptr[mezo]^.mezohossz);
 end;


{ Feladat : egy mez bersa a dbpuffer-ba                                }
{ Input   : mezo - a feldolgozand mez sorszma                          }
{           dbmezoptr[] (glob) - a feldolgozand mez lerja             }
{           tartalom - a mez j tartalma                                 }
{ Output  : dbpuffer    (glob) - a feldolgozand rekord                   }
procedure setfield(mezo:byte; tartalom:string);
 begin
   if length(tartalom)=dbmezoptr[mezo]^.mezohossz
      then move(tartalom[1],pufferptr(mezo)^,dbmezoptr[mezo]^.mezohossz);
 end;


{ Feladat : a memomez kiolvassa a memofile-bl                         }
{ Input   : rekord - a feldolgozand mez sorszma                       }
{ Output  : a memomez megjelentse a kpernyn                         }
procedure print_memo(rekord:string);
 var rekn:longint;
    i,memohossz,kod,numread :integer;
    kilepes:boolean;
    memo:array [1..512] of char;
 begin
   val(rekord,rekn,kod);
   if kod<>0 then exit;
   repeat
     writeln;writeln('memo:',rekn);
     seek(dbmemo,rekn*512);
     blockread(dbmemo,memo,512,numread);
     i:=0;
     repeat
       inc(i);
     until (memo[i]=chr($1a)) or (i>numread);
     if i<512
     then begin
            memohossz:=i-1;
            kilepes:=true;
          end
     else begin
            memohossz:=512;
            kilepes:=false;
          end;
     for i:=1 to memohossz do
        if memo[i]=chr(128+13)  then write(#13)
                                else write(memo[i]);
     inc(rekn);
   until kilepes;
   writeln;
 end;

end.
