(* express.pas *)

{ sztringben megadott kifejezs kirtkelse                }
{ a kifejezsben szerepelhetnek: (), +, -, *, / mveletek,  }
{ s az abs, round, trunc, sqrt, sqr, sin, cos, tan, arctan,}
{        ln, log, log2, exp fggvnyek                      }
{                                                           }
program kifejezes;
uses crt;

type exprstr=string[200];

var
  position : integer;    { az aktulis pozici a kpletben }
  ch : char;             { az aktulis karakter }

type
  { fggvnyek }
  builtin = (fabs, fround, ftrunc, fsqrt, fsqr, fsin, fcos, ftan,
	     farctan, fln, flog, flog2, fexp);
  builtinlist = array[builtin] of string[6];
  diray=array[1..4,1..2] of string [10];

const
  { fggvnynevek }
  builtinnames : builtinlist =
      ('abs', 'round', 'trunc', 'sqrt', 'sqr', 'sin', 'cos','tan',
        'arctan',  'ln', 'log', 'log2', 'exp');

var
   formula : exprstr;
   exprvl: real;
   errposition: integer;

{ --------------------------------------------------- )
{ a formula kvetkez karaktere a ch-ba, s a pozci }
{ aktualizlsa                                       }
procedure nextch;
 begin
   repeat
     inc(position);
     if position <= ord(formula[0])
        then ch := formula[position]
        else ch := chr(0)
   until ch <> ' '
 end;

{ ------------------------------------------------ )
{ a position pozcinban lev fggvny ellenrzse }
function thisfn(inp : exprstr; position : integer; fn : builtin) : boolean;
 var
   i : integer;
 begin
   thisfn := true;
   for i:=1 to ord(builtinnames[fn][0]) do
     if inp[i+position-1] <> builtinnames[fn,i] then thisfn := false
 end;

{ szmrtk }
function factor : real;forward;

{ ---------- az eljeles szmrtk ---------- }
function signedfactor : real;
 begin
   { a szkzk tlpse}
   while ch = ' ' do nextch;
   { negatv eljel }
   if ch = '-' then begin
                      nextch;
	  	      signedfactor := -factor
		    end

   { pozitv eljel }
   else if ch = '+' then begin
                           nextch;
	  		   signedfactor := factor
		    end
   else signedfactor := factor
 end;

{ ---------- operandus ---------- }
function term : real;
 var
   t, t2 : real;
 begin
   t := signedfactor;
   while (ch = '^') and (errposition = 0) do
     begin
       nextch;
       t2 := signedfactor;
     end;
   term := t
 end;

{ ---------- /, * egyszer kifejezs ---------- }
function simpleexpression : real;
 var
   s : real;
 begin
   s := term;
   while ((ch = '*') or (ch = '/') or (ch = 'm'))
         and (errposition = 0) do
     { oszts }
     if ch = '/' then begin
                        nextch;
			s := s / term
		      end
     { szorzs }
     else if ch = '*' then begin
                             nextch;
			     s := s * term
			   end
          else errposition := position;
   simpleexpression := s
 end;

{ ---------- +, - kifejezs ---------- }
function expression : real;
 var
   e : real;
 begin
   e := simpleexpression;
   while ((ch = '+') or (ch = '-')) and (errposition = 0) do
     { kivons }
     if ch = '-' then begin
                        nextch;
			e := e - simpleexpression
		      end
                 { sszeads }
                 else begin
                        nextch;
			e := e + simpleexpression
		      end;
   expression := e
 end;

{ ---------- szmrtk ----------}
function factor : real;
 var
   e,l : integer;
   found : boolean;
   f : real;
   fn : builtin;
   start : integer;
 begin
   if ((ch >= '0') and (ch <= '9')) or (ch = '.') then
     begin
       start := position;
       repeat nextch until (ch < '0') or (ch > '9');
       if ch = '.' then
	 repeat nextch until (ch < '0') or (ch > '9');
       if (ch='e') or (ch='e') then
	 begin
           nextch;
	   repeat nextch until (ch < '0') or (ch > '9')
	 end;
       val(copy(formula,start,position-start),f,errposition)
     end
   else if ch='(' then
     begin
       nextch;
       f := expression;
       if ch=')' then nextch
		 else errposition := position
     end
   else
     begin { bels fggvny hvsnak feldolgozsa }
       found := false;
       for fn := fabs to fexp do
         if not found then
           begin { a fggvnynv ellenrzse }
             l := ord(builtinnames[fn][0]);
	     if thisfn(formula,position,fn) then
               begin { a fggvny hvsa }
                 position := position + l - 1;
	         nextch;
                 f := factor;
                 case fn of
                   fabs:     f:=abs(f);
	           fround:   f:=round(f);
                   ftrunc:   f:=trunc(f);
	           fsqrt:    f:=sqrt(f);
                   fsqr:     f:=sqr(f);
                   fsin:     f:=sin(f);
                   fcos:     f:=cos(f);
                   ftan:     f:=sin(f)/cos(f);
                   farctan:  f:=arctan(f);
                   fln :     f:=ln(f);
                   flog:     f:=ln(f)/ln(10);
	           flog2:    f:=ln(f)/ln(2);
                   fexp:     f:=exp(f);
                 end; { case }
                 found := true;
               end; { a fggvny hvsa }
           end; { a fggvnynv ellenrzse }
       if not found then errposition := position;
     end; { bels fggvny hvsnak feldolgozsa }
     factor := f
 end;

{ ---------- a kirtkel eljrs ---------- }
procedure evaluate;
 begin
   { a sztring kisbetss alaktsa }
   for position:=1 to ord(formula[0]) do
     if (formula[position] >= 'a') and (formula[position] <= 'z') then
       formula[position] := chr(ord(formula[position]) + ord('a') - ord('a'));

   position := 0;
   errposition := 0;
   nextch;
   exprvl := expression;
   if ch <> chr(0) then errposition := position
 end;

{ ---------- az elfeldolgoz ---------- }
{ s   : kplet sztring                   }
{ dir : vltoztmb                      }
{ n   : a vltozk szma                 }
function preproc(s:string; dir:diray; n:integer):real;
 var
   sv, ss : string;
   i,ps,len : integer;
 begin
   ss:=s;
   { a vltozk rtkkel val felcserlse }
   for i:=1 to n do
    begin
      repeat
         ps:=pos(dir[i][1],ss);
         if ps<>0 then
                   begin
                     len:=length(dir[i][1]);
                     delete(ss,ps,len);
                     insert(dir[i][2],ss,ps);
                   end;
      until ps=0;
    end;
    { az j kpletsztring }
    formula:=ss;
    { kirtkelse }
    evaluate;
    { az rtk visszaadsa }
    preproc:=exprvl;
    { hibajelzs }
    if errposition<>0 then
                      begin
                        writeln(ss);
                        for i:=1 to errposition-1 do
                          write(' ');
                        write('^');
                        halt;
                      end;
 end;


{ ---------- fprogram ----------- }

const vars : diray=(('',''),
                    ('',''),
                    ('',''),
                    ('',''));

var step, _x, e , epas : real;
    sexp : string;
    nv, i : integer;

begin
  clrscr;
  writeln('  x':6, ' express':14, 'pascal':10);
  writeln;
  vars[1][1]:='_x';
  sexp:='exp((sin(_x)*cos(_x))/(1+sqrt(abs(_x))))/3';
  _x:=-2;
  step:=0.2;
  while (_x<2+step) do
    begin
      str(_x, vars[1][2]);
      e := preproc(sexp, vars,1);
      epas := exp((sin(_x)*cos(_x))/(1+sqrt(abs(_x))))/3;
      writeln(_x:10:6, e:10:6, epas:10:6);
      _x:=_x+step;
    end;
   readln;
   clrscr;
   write('A vltozk szma (0..4): '); readln(nv);
   writeln;
   for  i:=1 to nv do
    begin
      write('Az ', i, '. vltoz neve   : '); readln(vars[i][1]);
      write('Az ', i, '. vltoz rtke : '); readln(vars[i][2]);
      writeln;
    end;
   write('Krem a kiszmoland kifejezs : '); readln(sexp);
   writeln;
   e:=preproc(sexp, vars, nv);
   writeln('A kifejezs rtke           : ', e:11:6);
   readln;
end.
